-- HitsMode, by Allara


function HitsMode_Localize()


-- Colors
local WHT = "|cffffffff";
local BLK = "|cff000000";
local YEL = "|cffffff20";
local RED = "|cffff2020";
local GRN = "|cff20ff20";
local BLU = "|cff2020ff";
local HIL = "|cfffbd284";

-- BINDINGS
BINDING_HEADER_HITSMODE = "HitsMode";
BINDING_NAME_OPTIONSTOGGLE = "Show HitsMode Options Window";

-- INFO BOX
-- Be careful localizing the following text; the info box is limited to about 360 characters.
HITSMODE_OPTION_ONSHOW_INFO = "This is the HitsMode options window. The "..HIL.."General|r tab\ncontains global options. "..HIL.."Windows|r contains\noptions that affect the HitsMode chat windows.\n"..HIL.."Messages|r lets you control which combat messages are\ndisplayed and how. Finally, "..HIL.."Presets|r let you quickly\nconfigure HitsMode in many popular ways. Hover your mouse\nover an option for more help, and scroll down to see more options."
HITSMODE_OPTION_LOADDEFAULTS_INFO = "Loads the default options, overwriting all your\ncurrent options. "..RED.."THIS ACTION CANNOT BE UNDONE!|r";
HITSMODE_OPTION_LOADGLOBAL_INFO = "Loads options from the Global saved options. Use\nthis when you want to copy a configuration from one\ncharacter to another. Simply set your options, press\n"..YEL.."Save Global|r, switch characters, and press "..YEL.."Load Global|r.\n"..RED.."THIS ACTION CANNOT BE UNDONE!|r";
HITSMODE_OPTION_LOADGLOBAL_GLOBALNOTPRESENT_INFO = WHT.." Global options have not been saved yet, so they cannot be loaded.";
HITSMODE_OPTION_SAVEGLOBAL_INFO = "Saves the current options as the Global options.\nUse this when you want to copy a configuration\nfrom one character to another. Simply set your\noptions, press "..YEL.."Save Global|r, switch characters,\nand press "..YEL.."Load Global|r. "..RED.."THIS ACTION CANNOT\nBE UNDONE!|r";
HITSMODE_OPTION_TAB1_INFO = "The "..HIL.."General|r tab contains global options that affect the entire add-on.";
HITSMODE_OPTION_TAB2_INFO = "The "..HIL.."Windows|r tab contains options that apply to each individual chat window. You can configure each chat window separately for a large variety of possible setups.";
HITSMODE_OPTION_TAB3_INFO = "The "..HIL.."Messages|r tab contains options that let you choose which combat messages you'd like to show, in which window to show them, and in what color they should be displayed.";
HITSMODE_OPTION_TAB4_INFO = "The "..HIL.."Presets|r tab lets you quickly configure HitsMode in a variety of popular ways. Hover your mouse over each preset button to see a longer description.";


-- COMBAT OUTPUT STRING FRAGMENTS
HM_ChatMessages = {
        ["SUFFERS"] = "suffers",
        ["HITFOR"] = "hit for",
        ["CRITFOR"] = "crit for",
        ["MISS"] = "miss",
        ["PARRIES"] = "parries",
        ["EVADES"] = "evades",
        ["DODGES"] = "dodges",
        ["DEFLECTS"] = "deflects",
        ["BLOCKS"] = "blocks",
        ["RESISTS"] = "resists",
        ["ISIMMUNE"] = "is immune",
        ["ISIMMUNETO"] = "is immune to your",
        ["CRITSFOR"] = "crits for",
        ["HITSFOR"] = "hits for",
        ["BLOCK"] = "block",
        ["DEFLECT"] = "deflect",
        ["DODGE"] = "dodge",
        ["EVADE"] = "evade",
        ["AREIMMUNE"] = "are immune",
        ["PARRY"] = "parry",
        ["RESIST"] = "resist",
        ["MISSES"] = "misses",
        ["XP"] = "gain exp",
        ["BRACKETLEFT"] = "[",
        ["BRACKETRIGHT"] = "]",
        ["HEALFOR"] = "heal for",
        ["FADES"] = "fades",
        ["HEALSYOUFOR"] = "heals you for",
        ["SUFFER"] = "suffer",
        ["CRITHEALFOR"] = "crit heal for",
        ["CRITHEALSFOR"] = "crit heals for",
        ["FOR"] = "for",
        ["FALLFOR"] = "fall for",
        ["BURNFOR"] = "burn for",
        ["GAIN"] = "gain",
        ["GAINS"] = "gains",
        ["ISREMOVED"] = "is removed",
        ["GAINMANA"] = "gain mana",
        ["GAINATK"] = "gain",
        ["GAINENERGY"] = "gain energy",
        ["GAINRAGE"] = "gain rage",
        ["GAINREP"] = "gain reputation",
        ["LOSEREP"] = "lose reputation",
        ["BLOCKED"] = "blocked",
        ["ABSOR"] = "absorb",
        ["ABSORB"] = "absorbs",
        ["DMGABS"] = "absorb damage",
        ["WASABS"] = "was absorbed",
        ["PURGE"] = "was removed",
        ["INTER"] = "was interrupted",
        ["INTERS"] = "interrupted",
        ["SEPARATOR"] = "----",
        ["CDIVIDER"] = " - ",
        ["PLAYERSLAY"] = "have slain",
        ["OTHERSLAY"]  = "has slain",
        ["PLAYERCRAFT"] = "create",
        ["PLAYERLOOT"]  = "loot",
        ["ITEM_ENCH"]  = "enchant",
        ["AFFLICTED"]  = "afflicted by",
        ["DROPTOTEM"]  = "drop",
        ["CREATUDIES"] = "dies",
        ["HONOR"]       = "gain honor";
};





-- OUT OF DATE STUFF
-- Category headings
HMOptionsFrameCategories = {
        ["Combat"] = { index = 1 },
        ["Color Overlays"] = { index = 2 },
        ["Unit Names"] = { index = 3 },
        ["Verbose Mode"] = { index = 4 },
        ["Flags"] = { index = 5 },
        ["Other"] = { index = 6 }
};

-- Event and Damage option values
HMOptionsFrameEventFrames = {
        ["Show Player Melee"] = { index = 1, tooltipText = "Select to show your melee\ndamage against monsters.", HMVar = "SHOWPLAYERMELEE"},
        ["Show Monster Melee"] = { index = 2, tooltipText = "Select to show other monster's\nmelee damage against you.", HMVar = "SHOWMONSTERMELEE"},
        ["Show Player Misses"] = { index = 3, tooltipText = "Select to show your misses.", HMVar = "SHOWPLAYERMISSES"},
        ["Show Monster Misses"] = { index = 4, tooltipText = "Select to show other monster's misses.", HMVar = "SHOWMONSTERMISSES"},
        ["Show Player Block/Parry"] = { index = 5, tooltipText = "Select to show your\nblocks and parries.", HMVar = "SHOWPLAYERPARRY"},
        ["Show Monster Block/Parry"] = { index = 6, tooltipText = "Select to show other\nmonster's blocks and parries.", HMVar = "SHOWMONSTERPARRY"},
        ["Show Instant Spell Damage"] = { index = 7, tooltipText = "Select to show instant\nspell damage (such as nukes).", HMVar = "SHOWSPELL"},
        ["Show Periodic Spell Damage"] = { index = 8, tooltipText = "Select to show periodic\nspell damage (such as poison).", HMVar = "SHOWPERIODICSPELL"},
        ["Show Instant Heals"] = { index = 9, tooltipText = "Select to show instant heals.", HMVar = "SHOWHEAL"},
        ["Show Periodic Heals"] = { index = 10, tooltipText = "Select to show periodic heals\n(such as regeneration effects).", HMVar = "SHOWPERIODICHEAL"},
        ["Show Experience Gained"] = { index = 11, tooltipText = "Select to show experience\nyou have gained (includes\nquest experience).", HMVar = "SHOWEXP"},
        ["Show Resists"] = { index = 12, tooltipText = "Select to display spell resists.", HMVar = "SHOWRESISTS" },
        ["Show Brackets"] = { index = 13, tooltipText = "Select to show brackets\naround unit names.", HMVar = "SHOWBRACKETS" },
        ["Recolor Pet Damage"] = { index = 14, tooltipText = "Overlays the selected color\nover all pet numeric messages.\nFor example, white would make all\npet damage brighter. A pet crit\nwill not be double-overlayed.", HMVar = "RECOLORPET" },
        ["Recolor Crits"] = { index = 15, tooltipText = "Overlays the selected color over\ncrits of all types. For example,\nwhite would make all crits appear\nbrighter. A pet crit will not\nbe double-overlayed.", HMVar = "RECOLORCRIT" },
        ["Show You"] = { index = 16, tooltipText = "Shows the unit name for your\nevents. Unit names are only shown\nduring Verbose Mode.", HMVar = "SHOWME" },
        ["Show Pet"] = { index = 17, tooltipText = "Shows the unit name for your\npet's events. Unit names are only\nshown during Verbose Mode.", HMVar = "SHOWPET" },
        ["Show Monster"] = { index = 18, tooltipText = "Shows the unit name for all\nmonster events. Unit names are only\nshown during Verbose Mode.", HMVar = "SHOWMOB" },
        ["Enable Verbose Mode A"] = { index = 19, tooltipText = "Shows more information in chat.\nMode A looks like:\n  [You] hit for 12\n  [Wolf] hits for 8", HMVar = "VERBOSE" },
        ["Enable Verbose Mode B"] = { index = 20, tooltipText = "Shows more information in chat.\nMode B looks like:\n  [You] hit [Wolf] for 12\n  [Wolf] hits [You] for 8", HMVar = "VERBOSE2" },
        ["Flag Crits"] = { index = 21, tooltipText = "Puts a flag around all critical events.\nLooks like:\n  *1297*", HMVar = "SHOWCRITFLAG" },
        ["Show Skill Names"] = { index = 22, tooltipText = "Shows the name of the skill or spell\nthat was used, if any. This only\nworks in one of the verbose modes.", HMVar = "SHOWSKILL" },
};

-- Checkbox option values
HMOptionsFrameCheckButtons = {
        ["Enable HitsMode"] = { index = 1, tooltipText = "Enables or disables HitsMode. When\nenabling, this will display the selected\nchat window for you. Disabling HitsMode\nwill not close the chat window.", HMVar = "ENABLED"},
        ["Short Verbose Mode"] = { index = 2, tooltipText = "Eliminates the \"for\"\nat the end of all messages.", HMVar = "SHORTMODE" },
        ["Capitalize Text"] = { index = 3, tooltipText = "Capitalizes the beginning of\nsome verbose mode text.", HMVar = "CAPS" },
        ["Flag Heals"] = { index = 4, tooltipText = "Puts a plus sign in front of heals.\nLooks like:\n  +892", HMVar = "SHOWHEALFLAG" },
        ["Flag Pet Damage"] = { index = 5, tooltipText = "Puts a flag around all pet events.\nLooks like:\n  ~36~", HMVar = "SHOWPETFLAG" },
        ["Show Rested Experience"] = { index = 6, tooltipText = "Shows how much experience was rested\nexperience, if any. Looks like:\n  470 (+235)", HMVar = "SHOWRESTED" }
};

-- Slider options values
HMOptionsFrameSliders = {
        ["Output to Chat Window"] = { index = 1, HMVar = "CHATOUTPUT", minValue = 1, maxValue = 7, valueStep = 1, minText="1", maxText="7", tooltipText = "Selects which chat window HitsMode\noutputsto. There can be up to 7\nchat windows open at once.\nGeneral Chat is usually 1,\nand Combat Chat is usually 2.\nMove this slider until you find\nthe one you want to use.\nNote that HitsMode will ALWAYS\noverride whatever font size you've\npicked for the chat window\nyou select."},
        ["Text Size"] = { index = 2, HMVar = "TEXTSIZE", minValue = 2, maxValue = 64, valueStep = 1, minText="2 pt", maxText="64 pt", tooltipText = "Controls the size of the chat text. This\nallows you to bypass the UI's font size\nlimitations for extra big or small text (useful\nwhen reading HitsMode chat). This font size will\nALWAYS override WoW's font size settings\nfor the selected chat window."}
};


end
