--[[ HitsMode, by Allara ]]--


-- This is the main parser called by the OnEvent handler. Currently does plain-text parsing
-- of the chat message based on the event. This method requires you to know the exact text
-- in every combat message. The problem is it's not very portable, localizable, or reliable.
-- There is another way to do most of this -- look for it in a future version.

function HM_Parse(event, arg1)
        -- Attempt to restrict all the variables used into the current lexical scope. (Did I succeed?)
        local damage, spell, creatureName, targetName, petName, damageType, _, d, d2, resist;


        ------
        -- Begin processing chat events
        ------


        if  (event == "CHAT_MSG_COMBAT_SELF_HITS"
                or event == "CHAT_MSG_COMBAT_SELF_MISSES"
                or event == "CHAT_MSG_SPELL_SELF_DAMAGE"
                or event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE"
                or event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE"
                ) then

                for damage in string.gmatch(arg1, "You fall and lose (%d+) health.") do
                        HM_Output("You", nil, nil, "FALLFOR", "you_fall", damage, 0, arg1, event);
                        return;
                end

                for creatureName, damage, damageType, spell, petName in string.gmatch(arg1, "(.+) suffers (%d+) (.+) from your ([%a%s%:]+).(.*)") do
                        HM_Output("You", creatureName, spell, "HITFOR", "you_dot", damage.." "..damageType.." "..petName, 0, arg1, event);
                        return;
                end

                for spell, creatureName, damage, petName, petName in string.gmatch(arg1, "Your (.+) hits (.+) for ([%d]+[%s%a]*)([%p]+)([%(%a%s%d%)%+]*)") do
                        HM_Output("You", creatureName, spell, "HITFOR", "you_nuke", damage..petName, 0, arg1, event);
                        return;
                end

                for creatureName, damage in string.gmatch(arg1, "You hit (.+) for (%d+)") do
                        HM_Output("You", creatureName, nil, "HITFOR", "you_melee", damage, 0, arg1, event);
                        return;
                end
                for spell, creatureName, damage, petName, petName in string.gmatch(arg1, "Your (.+) crits (.+) for ([%d]+[%s%a]*)([%p]+)([%(%a%s%d%)%+]*)") do
                        HM_Output("You", creatureName, spell, "CRITFOR", "you_nuke", damage..petName, 1, arg1, event);
                        return;
                end
                for creatureName, damage in string.gmatch(arg1, "You crit (.+) for (%d+)") do
                        HM_Output("You", creatureName, nil, "CRITFOR", "you_melee", damage, 1, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You miss (.+).") do
                        HM_Output("You", creatureName, nil, "MISS", "you_miss", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack. (.+) parries.") do
                        HM_Output(creatureName, "You", nil, "PARRIES", "mob_parry", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack. (.+) evades.") do
                        HM_Output(creatureName, "You", nil, "EVADES", "mob_evade", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack. (.+) dodges.") do
                        HM_Output(creatureName, "You", nil, "DODGES", "mob_dodge", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack. (.+) deflects.") do
                        HM_Output(creatureName, "You", nil, "DEFLECTS", "mob_deflect", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack. (.+) blocks.") do
                        HM_Output(creatureName, "You", nil, "BLOCKS", "mob_block", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack. (.+) absorbs all the damage.") do
                        HM_Output("You", creatureName, nil, "HITFOR", "mob_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) is absorbed by (.+).") do
                        HM_Output("You", creatureName, spell, "HITSFOR", "mob_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) was blocked by (.+).") do
                        HM_Output(creatureName, "You", spell, "BLOCKS", "mob_block", nil, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) was deflected by (.+).") do
                        HM_Output(creatureName, "You", spell, "DEFLECTS", "mob_deflect", nil, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) was dodged by (.+).") do
                        HM_Output(creatureName, nil, nil, "DODGES", "mob_dodge", spell, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) was evaded by (.+).") do
                        HM_Output(creatureName, "You", spell, "EVADES", "mob_evade", nil, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) is parried by (.+).") do
                        HM_Output(creatureName, nil, nil, "PARRIES", "mob_parry", spell, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) was resisted by (.+).") do
                        HM_Output(creatureName, "You", spell, "RESISTS", "mob_resist", nil, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) failed. (.+) is immune.") do
                        HM_Output(creatureName, nil, nil, "ISIMMUNE", "mob_immune", spell, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "You attack but (.+) is immune.") do
                        HM_Output(creatureName, "You", nil, "ISIMMUNE", "mob_immune", nil, 0, arg1, event);
                        return;
                end
                for spell, creatureName in string.gmatch(arg1, "Your (.+) missed (.+).") do
                        HM_Output("You", creatureName, spell, "MISS", "you_miss", nil, 0, arg1, event);
                        return;
                end
                for spell in string.gmatch(arg1, "You suffer (%d+) points of fire damage.") do
                        HM_Output("You", nil, nil, "BURNFOR", "mob_dot", spell, 0, arg1, event);
                        return;
                end
                --elseif (event == "SPELLCAST_INTERRUPTED") then
                for creatureName, spell in string.gmatch(arg1, "You interrupt (.+)'s (.+).") do
                        HM_Output(creatureName, "You", spell, "INTER", "you_inter", nil, 0, arg1, event);
                        return;
                end


        elseif (event == "CHAT_MSG_COMBAT_PET_HITS") then

                for petName, creatureName, damage in string.gmatch(arg1, "(.+) crits (.+) for (%d+).") do
                        HM_Output(petName, creatureName, nil, "CRITSFOR", "pet_melee", damage, 1, arg1, event);
                        return;
                end

                for petName, creatureName, damage in string.gmatch(arg1, "(.+) hits (.+) for (%d+).") do
                        HM_Output(petName, creatureName, nil, "HITSFOR", "pet_melee", damage, 0, arg1, event);
                        return;
                end





        elseif (event == "CHAT_MSG_SPELL_PET_DAMAGE") then

                for petName, spell, creatureName, damage in string.gmatch(arg1, "(.+)'s (.+) hits (.+) for (.+)") do
                        if (HM_IsPet(petName)) then
                                HM_Output(petName, creatureName, spell, "HITSFOR", "pet_nuke", damage, 0, arg1, event);
                        end
                        return;
                end

                for petName, spell, creatureName, damage in string.gmatch(arg1, "(.+)'s (.+) crits (.+) for (.+)") do
                        if (HM_IsPet(petName)) then
                                HM_Output(petName, creatureName, spell, "CRITSFOR", "pet_nuke", damage, 1, arg1, event);
                        end
                        return;
                end

                for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) was blocked by (.*).") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, spell, "BLOCKS", "vspet_block", nil, 0, arg1, event);
                        end
                        return;
                end

                for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) was dodged by (.*).") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, spell, "DODGES", "vspet_dodge", nil, 0, arg1, event);
                        end
                        return;
                end

    for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) was evaded by (.*).") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, spell, "EVADES", "vspet_evade", nil, 0, arg1, event);
                        end
                        return;
                end

    for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) fails. (.+) is immune.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, spell, "ISIMMUNE", "vspet_immune", nil, 0, arg1, event);
                        end
                        return;
                end

                --for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) was resisted by (.*).") do
                        --if (HM_IsPet(petName)) then
                                --HM_Output(creatureName, petName, spell, "RESISTS", "vspet_resist", nil, 0, arg1, event);
                        --end
                        --return;
                --end

    for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) misses (.*).") do
                        if (HM_IsPet(petName)) then
                           HM_Output(petName, creatureName, spell, "MISS", "pet_miss", nil, 0, arg1, event);
                        end
                        return;
                end

                for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) missed (.*).") do
                        if (HM_IsPet(petName)) then
                                HM_Output(petName, creatureName, spell, "MISS", "pet_miss", nil, 0, arg1, event);
                        end
                        return;
                end

                for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) failed. (.+) is immune.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, spell, "ISIMMUNE", "vspet_immune", nil, 0, arg1, event);
                        end
                        return;
                end

                for petName, spell, creatureName in string.gmatch(arg1, "(.+)'s (.+) was deflected by (.+).") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, spell, "DEFLECTS", "vspet_deflect", nil, 0, arg1, event);
                        end
                        return;
                end


        elseif (event == "CHAT_MSG_COMBAT_PET_MISSES") then

                for petName, creatureName in string.gmatch(arg1, "(.+) misses (.*).") do
                        if (HM_IsPet(petName)) then
                                HM_Output(petName, creatureName, nil, "MISS", "pet_miss", nil, 0, arg1, event);
                        end
                        return;
                end

                for petName, creatureName in string.gmatch(arg1, "(.+) attacks. (.+) parries.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, nil, "PARRIES", "vspet_parry", nil, 0, arg1, event);
                        end
                        return;
                end
                for petName, creatureName in string.gmatch(arg1, "(.+) attacks. (.+) evades.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, nil, "EVADES", "vspet_evade", nil, 0, arg1, event);
                        end
                        return;
                end
                for petName, creatureName in string.gmatch(arg1, "(.+) attacks. (.+) dodges.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, nil, "DODGES", "vspet_dodge", nil, 0, arg1, event);
                        end
                        return;
                end
                for petName, creatureName in string.gmatch(arg1, "(.+) attacks. (.+) deflects.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, nil, "DODGES", "vspet_deflect", nil, 0, arg1, event);
                        end
                        return;
                end
                for petName, creatureName in string.gmatch(arg1, "(.+) attacks. (.+) blocks.") do
                        if (HM_IsPet(petName)) then
                                HM_Output(creatureName, petName, nil, "BLOCKS", "vspet_block", nil, 0, arg1, event);
                        end
                        return;
                end


        elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS"
                or event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS"
                ) then

--                for creatureName, targetName, damage, blockedAmount in string.gmatch(arg1, "(.+) hits (.+) for (%d+). (.+)") do
--                        if (strfind(event, "HOSTILEPLAYER") and string.upper(targetName) ~= "YOU") then return; end
--                        if (HM_IsPet(targetName)) then
--                                HM_Output(creatureName, targetName, nil, "HITSFOR", "vspet_melee", damage, 0, arg1, event);
--                                HM_Output("You", nil, nil, "BLOCKED", "vspet_blockedamount", blockedAmount, 0, arg1, event);
--                        else
--                                HM_Output(creatureName, targetName, nil, "HITSFOR", "mob_melee", damage, 0, arg1, event);
--                                HM_Output("You", nil, nil, "BLOCKED", "you_blockedamount", blockedAmount, 0, arg1, event);
--                        end
--                        return;
--                end
                for creatureName, targetName, damage, petName, petName in string.gmatch(arg1, "(.+) hits (.+) for ([%d]+[%s%a]*)([%p]+)([%a%s%d%(%)]*)") do
                        if (strfind(event, "HOSTILEPLAYER") and string.upper(targetName) ~= "YOU") then return; end
                        if (HM_IsPet(targetName)) then
                                HM_Output(creatureName, targetName, nil, "HITSFOR", "vspet_melee", damage..petName, 0, arg1, event);
                        else
                                HM_Output(creatureName, targetName, nil, "HITSFOR", "mob_melee", damage..petName, 0, arg1, event);
                        end
                        return;
                end
                for creatureName, targetName, damage, petName, petName in string.gmatch(arg1, "(.+) crits (.+) for ([%d]+[%s%a]*)([%p]+)([%a%s%d%(%)]*)") do
                        if (strfind(event, "HOSTILEPLAYER") and string.upper(targetName) ~= "YOU") then return; end
                        if (HM_IsPet(targetName)) then
                                HM_Output(creatureName, targetName, nil, "CRITSFOR", "vspet_melee", damage..petName, 1, arg1, event);
                        else
                                HM_Output(creatureName, targetName, nil, "CRITSFOR", "mob_melee", damage..petName, 1, arg1, event);
                        end
                        return;
                end


        elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"
                or event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE"
                ) then

                for creatureName, spell, targetName, damage, petName, resist in string.gmatch(arg1, "(.+)'s (.+) hits (.+) for ([%d]+[%s%a]*)([%p]+)([%a%s%d%(%)]*)") do
                        if (strfind(event, "HOSTILEPLAYER") and string.upper(targetName) ~= "YOU") then return; end
                        if (HM_IsPet(targetName)) then
                                HM_Output(creatureName, targetName, spell, "HITSFOR", "vspet_nuke", damage..resist, 0, arg1, event);
                        else
                                HM_Output(creatureName, targetName, spell, "HITSFOR", "mob_nuke", damage..resist, 0, arg1, event);
                        end
                        return;
                end

                for creatureName, spell, targetName, damage, petName, resist in string.gmatch(arg1, "(.+)'s (.+) crits (.+) for ([%d]+[%s%a]*)([%p]+)([%a%s%d%(%)]*)") do
                        if (strfind(event, "HOSTILEPLAYER") and string.upper(targetName) ~= "YOU") then return; end
                        if (HM_IsPet(targetName)) then
                                HM_Output(creatureName, targetName, spell, "CRITSFOR", "vspet_nuke", damage..resist, 1, arg1, event);
                        else
                                HM_Output(creatureName, targetName, spell, "CRITSFOR", "mob_nuke", damage..resist, 1, arg1, event);
                        end
                        return;
                end

                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) was blocked%.") do
                        HM_Output("You", creatureName, spell, "BLOCK", "you_block", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) was deflected%.") do
                        HM_Output("You", creatureName, spell, "DEFLECT", "you_deflect", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) was dodged%.") do
                        HM_Output("You", creatureName, spell, "DODGE", "you_dodge", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) was evaded%.") do
                        HM_Output("You", creatureName, spell, "EVADE", "you_evade", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) failed. You are immune.") do
                        HM_Output("You", creatureName, spell, "AREIMMUNE", "you_immune", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks but you are immune.") do
                        HM_Output("You", creatureName, nil, "AREIMMUNE", "you_immune", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You absorb all the damage.") do
                        HM_Output(creatureName, "You", nil, "HITSFOR", "you_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "You absorb (.+)'s (.+).") do
                        HM_Output(creatureName, "You", spell, "HITSFOR", "you_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) misses you.") do
                        HM_Output(creatureName, "You", spell, "MISSES", "you_miss", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "You parry (.+)'s (.+)") do
                        HM_Output("You", creatureName, spell, "PARRY", "you_parry", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) was parried.") do
                        HM_Output("You", creatureName, spell, "PARRY", "you_parry", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) was resisted.") do
                        --if (strfind(event, "HOSTILEPLAYER")) then return; end
                        HM_Output("You", creatureName, spell, "RESIST", "you_resist", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+) interrupts your (.+).") do
                        HM_Output("You", creatureName, spell, "INTERS", "mob_melee", nil, 0, arg1, event);
                        return;
                end



        elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES"
                or event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES"
                ) then

                for creatureName, targetName in string.gmatch(arg1, "(.+) misses (.+).") do
                        if (strfind(event, "HOSTILEPLAYER") and string.upper(targetName) ~= "YOU") then return; end
                        HM_Output(creatureName, targetName, nil, "MISSES", "mob_miss", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You parry.") do
                        HM_Output("You", creatureName, nil, "PARRY", "you_parry", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You evade.") do
                        HM_Output("You", creatureName, nil, "EVADE", "you_evade", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You dodge.") do
                        HM_Output("You", creatureName, nil, "DODGE", "you_dodge", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You deflect.") do
                        HM_Output("You", creatureName, nil, "DEFLECT", "you_deflect", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You block.") do
                        HM_Output("You", creatureName, nil, "BLOCK", "you_block", nil, 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks. You absorb all the damage.") do
                        HM_Output(creatureName, "You", nil, "HITSFOR", "you_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "You absorb (.+)'s (.+).") do
                        HM_Output(creatureName, "You", spell, "HITSFOR", "you_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end
                for creatureName in string.gmatch(arg1, "(.+) attacks but you are immune.") do
                        HM_Output("You", creatureName, nil, "AREIMMUNE", "you_immune", nil, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) failed. You are immune.") do
                        HM_Output("You", creatureName, spell, "AREIMMUNE", "you_immune", nil, 0, arg1, event);
                        return;
                end



        -- Periodic spell/heal events
        elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then

                -- Damage over time
                for damage, damageType, creatureName, spell, petName, petName in string.gmatch(arg1, "You suffer (%d+) (.+) damage from (.+)'s ([%a%s]+[%:%s%a%']*)([%p]+)([%a%s%d%(%)]*)") do
                        HM_Output("You", creatureName, spell, "SUFFER", "mob_dot", damage.." "..damageType.." "..petName, 0, arg1, event);
                        return;
                end
                
                for spell in string.gmatch(arg1, "You are afflicted by (.+).") do
                        HM_Output("You", nil, nil, "AFFLICTED", "you_afflicted", spell, 0, arg1, event);
                        return;
                end
                
                -- Damage over time with resisted amount
                -- for damage, damageType, creatureName, spell, petName in string.gmatch(arg1, "You suffer (%d+) (.+) damage from (.+)'s (.+). (%d*)") do
                --        HM_Output("You", creatureName, spell, "SUFFER", "mob_dot", damage..petName, 0, arg1, event);
                --        return;
                -- end
                
                ----- NEED THE TEXT FOR VSPET_DOT MESSAGES HERE !!!!!!
                
                -- Heal over time, others periodic healing you
                for creatureName, damage in string.gmatch(arg1, "(.+) heals you for (%d+)") do
                        HM_Output(creatureName, "You", nil, "HEALSYOUFOR", "you_are_hot", damage, 0, arg1, event);
                        return;
                end
                
                -- Other's heal over time on you
                for damage, creatureName, spell in string.gmatch(arg1, "You gain (%d+) health from (.+)'s (.+).") do
                        HM_Output(creatureName, "You", spell, "HEALSYOUFOR", "others_hot_you", damage, 0, arg1, event);
                        return;
                end
                for creatureName, spell in string.gmatch(arg1, "You absorb (.+)'s (.+).") do
                        HM_Output(creatureName, "You", spell, "HITSFOR", "you_absorb", "0 Physical damage (100% absorbed)", 0, arg1, event);
                        return;
                end



        -- Something fades on you
        elseif (event == "CHAT_MSG_SPELL_AURA_GONE_SELF") then
                for spell in string.gmatch(arg1, "(.+) fades from you.") do
                        HM_Output("You", nil, spell, "FADES", "you_fades", nil, 0, arg1, event);
                        return;
                end


        -- Something fades on other
        elseif (event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") then
                for spell, creatureName in string.gmatch(arg1, "(.+) fades from (.+).") do
                        HM_Output(creatureName, nil, spell, "FADES", "others_fade", nil, 0, arg1, event);
                        return;
                end


        elseif (event == "CHAT_MSG_SPELL_BREAK_AURA") then
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) is removed.") do
                        if (UnitName("target") == creatureName) then
                                HM_Output(creatureName, nil, spell, "PURGE", "you_purge", nil, 0, arg1, event);
                        end
                        return;
                end
        
        




        -- Mob gains a buff
        elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then
        
                -- Mob gains health from a buff
                --for creatureName, damage, temp, spell in string.gmatch(arg1, "(.+) gains (%d+) health from (.+)'s (.+).") do
                        --HM_Output(creatureName, nil, spell, "HEALFOR", "mob_hot", damage, 0, arg1, event);
                        --return;
                --end

                -- Mob gains a generic buff
                --for creatureName, spell in string.gmatch(arg1, "(.+) gains (.+).") do
                        --HM_Output(creatureName, nil, spell, "GAINS", "mob_gains", nil, 0, arg1, event);
                        --return;
                --end 


        elseif (event == "CHAT_MSG_SPELL_SELF_BUFF") then

                -- Self instant heal
                for spell, targetName, damage in string.gmatch(arg1, "Your (.+) critically heals (.+) for (%d+).") do
                        HM_Output("You", targetName, spell, "CRITHEALFOR", "you_heal", damage, 1, arg1, event);
                        HM_Output("You", targetName, spell, "CRITHEALFOR", "you_healyourself", damage, 1, arg1, event);
                        return;
                end
                for spell, targetName, damage in string.gmatch(arg1, "Your (.+) heals (.+) for (%d+).") do
                        HM_Output("You", targetName, spell, "HEALFOR", "you_heal", damage, 0, arg1, event);
                        HM_Output("You", targetName, spell, "HEALFOR", "you_healyourself", damage, 0, arg1, event);
                        return;
                end

                -- You dispelled something
                for creatureName, spell in string.gmatch(arg1, "(.+)'s (.+) is removed.") do
                        HM_Output(creatureName, nil, spell, "ISREMOVED", "mob_debuff", nil, 0, arg1, event);
                        return;
                end

                -- You gain energy
                for damage in string.gmatch(arg1, "You gain (.+) Energy") do
                        HM_Output("You", nil, nil, "GAINENERGY", "you_gainmana", damage, 0, arg1, event);
                         return;
                end
                
                -- You gain rage
                for damage in string.gmatch(arg1, "You gain (%d+) Rage") do
                        HM_Output("You", nil, nil, "GAINRAGE", "you_gainmana", damage, 0, arg1, event);
                         return;
                end

                -- You gain mana
                for damage in string.gmatch(arg1, "You gain (%d+) Mana") do
                        HM_Output("You", nil, nil, "GAINMANA", "you_gainmana", damage, 0, arg1, event);
                         return;
                end
                for damage, petName, spell in string.gmatch(arg1, "You gain (%d+) extra ([%a]+) through (.+).") do
                        HM_Output("You", nil, spell, "GAINATK", "you_gainatk", damage.." "..petName , 0, arg1, event);
                         return;
                end
                for spell in string.gmatch(arg1, "You cast (.+) Totem.") do
                        HM_Output("You", spell.." Totem", nil, "DROPTOTEM", "you_totem", nil, 0, arg1, event);
                        return;
                end


        -- Others instant healing you
         elseif (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF") then
                for creatureName, spell, damage in string.gmatch(arg1, "(.+)%'s (.+) critically heals you for (%d+)") do
                        HM_Output(creatureName, "you", spell, "CRITHEALFOR", "others_heal_you", damage, 1, arg1, event);
                        return;
                end
                for creatureName, spell, damage in string.gmatch(arg1, "(.+)%'s (.+) heals you for (%d+)") do
                        HM_Output(creatureName, "you", spell, "HEALFOR", "others_heal_you", damage, 0, arg1, event);
                        return;
                end

        elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS") then
                -- Self periodic heal
                --for damage, spell, spell in string.gmatch(arg1, "You gain (%d+) health from (.+)'s (.+).") do
                --        HM_Output("You", "You", spell, "HEALFOR", "you_are_hot", damage, 0, arg1, event);
                --        return;
                --end
                for damage, petName, spell in string.gmatch(arg1, "You gain (%d+) health from (.+)'s (.+).") do
                        HM_Output(petName, "You", spell, "HEALFOR", "you_are_hot", damage, 0, arg1, event);
                        return;
                end
                for damage, spell in string.gmatch(arg1, "You gain (%d+) health from (.+).") do
                        HM_Output("You", "You", spell, "HEALFOR", "you_are_hot", damage, 0, arg1, event);
                        return;
                end
                -- You gain mana
                for damage in string.gmatch(arg1, "You gain (%d+) Mana") do
                        HM_Output("You", nil, nil, "GAINMANA", "you_gainmana", damage, 0, arg1, event);
                         return;
                end
                -- You gain energy
                for damage in string.gmatch(arg1, "You gain (.+) Energy") do
                        HM_Output("You", nil, nil, "GAINENERGY", "you_gainmana", damage, 0, arg1, event);
                         return;
                end
                -- You gain rage
                for damage in string.gmatch(arg1, "You gain (%d+) Rage") do
                        HM_Output("You", nil, nil, "GAINRAGE", "you_gainmana", damage, 0, arg1, event);
                         return;
                end

                -- You gain a spell
                for spell in string.gmatch(arg1, "You gain (.+).") do
                        HM_Output("You", nil, spell, "GAIN", "you_gain", nil, 0, arg1, event);
                        return;
                end

                return;

        elseif (event == "CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS") then
                for creatureName, damage, spell in string.gmatch(arg1, "(.+) gains (%d+) health from your (.+).") do
                        HM_Output("You", creatureName, spell, "HEALFOR", "you_hot_others", damage, 0, arg1, event);
                        return;
                end

        elseif (event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS") then
                -- You gain mana
                for damage in string.gmatch(arg1, "You gain (%d+) Mana") do
                        HM_Output("You", nil, nil, "GAINMANA", "you_gainmana", damage, 0, arg1, event);
                         return;
                end
                for creatureName, damage, spell in string.gmatch(arg1, "(.+) gains (%d+) health from your (.+).") do
                        HM_Output("You", creatureName, spell, "HEALFOR", "you_hot_others", damage, 0, arg1, event);
                        return;
                end
                
        -- Monster death
        elseif (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
                -- HM_OutputConfiguredString("mob_died", "SEPARATOR");
                for hax in string.gmatch(arg1, "You have slain (.+)!") do
                        HM_Output("You", hax, nil, "PLAYERSLAY", "mob_died", nil, 0, arg1, event);
                        return;
                end
                for creatureName, petName in string.gmatch(arg1, "(.+) is slain by (.+)!") do
                        HM_Output(petName, creatureName, nil, "OTHERSLAY", "mob_died", nil, 0, arg1, event);
                end
                for hax in string.gmatch(arg1, "(.+) dies.") do
                        HM_OutputConfiguredString("mob_died_sep", "SEPARATOR");
                end
                for creatureName in string.gmatch(arg1, "(.+) dies.") do
                        HM_Output(creatureName, nil, nil, "CREATUDIES", "mob_dies", nil, 0, arg1, event);
                end
                return;


                -- REPUTATION GAIN / LOSS
        elseif (event == "CHAT_MSG_COMBAT_FACTION_CHANGE") then
                for spell, damage in string.gmatch(arg1, "Reputation with (.+) increased by (%d+).") do
                       HM_Output("You", nil, nil, "GAINREP", "you_gain_rep", spell.." "..damage, 0, arg1, event);
                       return;
                end
                for spell, damage in string.gmatch(arg1, "Reputation with (.+) decreased by (%d+).") do
                       HM_Output("You", nil, nil, "LOSEREP", "you_gain_rep", spell.." "..damage, 0, arg1, event);
                       return;
                end
                
                
        elseif (event == "CHAT_MSG_LOOT") then
                for spell in string.gmatch(arg1, "You create: (.+).") do
                       HM_Output("You", nil, nil, "PLAYERCRAFT", "you_craft", spell, 0, arg1, event);
                       return;
                end
                for spell in string.gmatch(arg1, "You receive loot: (.+).") do
                       HM_Output("You", nil, nil, "PLAYERLOOT", "you_loot", spell, 0, arg1, event);
                       return;
                end
                for spell in string.gmatch(arg1, "Your share of the loot is (.+).") do
                       HM_Output("You", nil, nil, "PLAYERLOOT", "you_loot", spell, 0, arg1, event);
                       return;
                end
                for petName, spell in string.gmatch(arg1, "(.+) receives loot: (.+).") do
                       HM_Output(petName, nil, nil, "PLAYERLOOT", "they_loot", spell, 0, arg1, event);
                       return;
                end
        
        elseif (event == "CHAT_MSG_SPELL_ITEM_ENCHANTMENTS") then
                for spell, damage in string.gmatch(arg1, "You cast (.+) on your (.+).") do
                       HM_Output("You", damage, spell, "ITEM_ENCH", "you_ench", nil, 0, arg1, event);
                       return;
                end

        elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
                for spell in string.gmatch(arg1, "([%d]+)") do
                        HM_Output("You", nil, nil, "HONOR", "you_gain_honor", "+"..spell, 0, arg1, event);
                        return;
                end
                for spell in string.gmatch(arg1, "You have been awarded ([%d]+) honor.") do
                        HM_Output("You", nil, nil, "HONOR", "you_gain_honor", "+"..spell, 0, arg1, event);
                        return;
                end

        -- Experience gain
        elseif (event == "CHAT_MSG_COMBAT_XP_GAIN") then
                _, _, d = string.find(arg1, ".* gain (%d+).*");
                _, _, d2 = string.find(arg1, "experience%. %(%+(%d+) exp Rested bonus");
                if (d2 ~= nil and HM_GetValue("showrested", 1) == 1) then
                        d = d.." (+"..d2..")";
                end
                HM_Output("You", nil, nil, "XP", "exp", d, 0, arg1, event);


        else
                -- HM_Output("You", nil, event, "GAIN", "you_gain", nil, 0, arg1, event);
                -- Unhandled event
        end
        
        
        -- Unhandled event
        if (HM_GetValue("debug") == 1) then
                HM_Print("--"..HM_BCC(.5, 1, .5).."HM Unparsed event fired:");
                HM_Print(HM_BCC(1, .5, .5)..event);
                HM_Print(HM_BCC(.5, .5, 1)..arg1..HM_BCC(1, 1, 1).."--");
        end
end
